SystemOrganization addCategory: #TestCaseCreator!

!Browser methodsFor: '*TestCaseCreator' stamp: ''!
createTestCase
	TestCaseCreator createFor: self selectedClass method: self selectedMessageName! !

!Browser methodsFor: '*TestCaseCreator' stamp: 'minami 3/16/2007 22:42'!
createTestCaseClass
	TestCaseCreator createFor: self selectedClass! !

Object subclass: #TestCaseCreator
	instanceVariableNames: 'targetClassDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestCaseCreator'!

!TestCaseCreator class methodsFor: 'private' stamp: 'minami 4/24/2002 01:59'!
categoryNameToTestCategoryName: nameOfCategory
	^ (nameOfCategory , '-Tests') asString! !

!TestCaseCreator class methodsFor: 'private' stamp: 'minami 4/24/2002 01:52'!
classNameToTestClassName: nameOfClass 
	^ (nameOfClass , 'TestCase') asSymbol! !

!TestCaseCreator class methodsFor: 'facade api' stamp: 'minami 4/24/2002 02:27'!
createFor: aClass 
	self createFor: aClass method: nil! !

!TestCaseCreator class methodsFor: 'facade api' stamp: 'minami 3/16/2007 22:24'!
createFor: aClass method: nameOfMethod 
	| creator testClassName testCategoryName testMethodName |
	creator := self new.
	testClassName := self classNameToTestClassName: aClass name.
	testCategoryName := self categoryNameToTestCategoryName: aClass category.
	testMethodName := nameOfMethod 
						ifNotNil: [self methodNameToTestMethodName: nameOfMethod asString].
						
	creator createTestClass: testClassName category: testCategoryName.
	creator addRunningMethods.
	testMethodName isNil
		ifFalse: [creator
				addMethod: testMethodName
				statements: (self testMethodTemplate format: {testClassName. testMethodName})
				category: creator testingCategory].
			
	self defaultBrowser fullOnClass: creator targetClassDescription selector: testMethodName! !

!TestCaseCreator class methodsFor: 'defaults' stamp: 'minami 3/16/2007 22:04'!
defaultBrowser
	| browserClass |
	browserClass := Smalltalk at: #TestBrowser ifAbsent: [].
	browserClass isNil
		ifTrue: [browserClass := Browser].
	^ browserClass! !

!TestCaseCreator class methodsFor: 'private' stamp: 'minami 4/24/2002 13:42'!
methodNameToTestMethodName: nameOfMethod 
	"TestCaseCreator methodNameToTestMethodName: 'aaa:bbb:ccc:'"
	| stream fromCol testMethodName |
	fromCol := OrderedCollection new.
	testMethodName := 'test'.
	stream := ReadStream on: nameOfMethod.
	[stream atEnd]
		whileFalse: [fromCol
				add: (stream upTo: $:)].
	fromCol
		do: [:each | 
			each at: 1 put: each first asUppercase.
			testMethodName := testMethodName , each].
	^ testMethodName! !

!TestCaseCreator class methodsFor: 'private' stamp: 'minami 3/16/2007 02:21'!
testMethodTemplate
^ '"{1} debug: #{2}"

	self assert: false.
'! !

!TestCaseCreator methodsFor: 'actions' stamp: 'minami 3/16/2007 02:24'!
addMethod: nameOfMethod statements: statements category: aMethodCategory 
	| aStream |
	(self targetClassDescription includesSelector: nameOfMethod asSymbol)
		ifTrue: 
			["do nothing"
			"PopUpMenu inform: nameOfMethod , ' is already exists!!'"]
		ifFalse: 
			[aStream := WriteStream on: String new.
			aStream nextPutAll: nameOfMethod asSymbol.
			statements isNil
				ifTrue: [aStream nextPutAll: '']
				ifFalse: [aStream cr; tab; nextPutAll: statements].
			self targetClassDescription compile: aStream contents classified: aMethodCategory]! !

!TestCaseCreator methodsFor: 'actions' stamp: 'minami 4/24/2002 01:57'!
addRunningMethods
	| aCategory |
	aCategory := self runningCategory.
	self
		addMethod: self setUpMethodName
		statements: self setUpStatements
		category: aCategory.
	self
		addMethod: self tearDownMethodName
		statements: self tearDownStatements
		category: aCategory! !

!TestCaseCreator methodsFor: 'actions' stamp: 'minami 3/16/2007 02:25'!
createTestClass: nameOfTestCase category: category 
	| testCase |
	testCase := Smalltalk
				at: nameOfTestCase
				ifAbsent: [].
	testCase isNil
		ifTrue: 
			[testCase := self defaultParentTestClass
						subclass: nameOfTestCase
						instanceVariableNames: ''
						classVariableNames: ''
						poolDictionaries: ''
						category: category]
		ifFalse: 
			["do nothing"
			"PopUpMenu inform: nameOfTestCase , ' is already exists!!'"].
	self targetClassDescription: testCase! !

!TestCaseCreator methodsFor: 'browser' stamp: 'minami 3/16/2007 22:05'!
defaultBrowser
	^ self class defaultBrowser! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 4/24/2002 01:55'!
defaultParentTestClass
	^ TestCase! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 4/24/2002 01:56'!
runningCategory
	^ #running! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 4/24/2002 01:57'!
setUpMethodName
	^ #setUp! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 3/16/2007 02:22'!
setUpStatements
	^ '"This method is called before each individual test case is ran"'! !

!TestCaseCreator methodsFor: 'accessing' stamp: 'minami 4/24/2002 01:33'!
targetClassDescription
	^ targetClassDescription! !

!TestCaseCreator methodsFor: 'accessing' stamp: 'minami 4/22/2002 02:00'!
targetClassDescription: aTargetClassDescription
	targetClassDescription := aTargetClassDescription! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 4/24/2002 01:57'!
tearDownMethodName
	^ #tearDown! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 3/16/2007 02:22'!
tearDownStatements
	^ '"This method is called after each individual test case is ran"'! !

!TestCaseCreator methodsFor: 'factory' stamp: 'minami 4/24/2002 02:41'!
testingCategory
	^ #testing! !

ServiceProvider subclass: #TestCaseCreatorServiceProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TestCaseCreator'!

!TestCaseCreatorServiceProvider class methodsFor: 'initialization' stamp: 'minami 3/16/2007 22:47'!
initialize 
	ServiceRegistry current buildProvider: self new! !

!TestCaseCreatorServiceProvider methodsFor: 'saved preferences' stamp: 'minami 3/16/2007 22:17'!
browserClassMenucreateTestCaseClass
	^ #(#'Items in browserClassMenu:' #createTestCaseClass 10 )! !

!TestCaseCreatorServiceProvider methodsFor: 'saved preferences' stamp: 'minami 3/17/2007 00:47'!
browserMethodMenucreateTestCase
	^ #(#'Items in browserMethodMenu:' #createTestCase 10 )! !

!TestCaseCreatorServiceProvider methodsFor: 'services' stamp: 'minami 3/17/2007 01:00'!
createTestCase
	^ ServiceAction
		text: 'Create/Browse test case'
		button: 'create/browse test case'
		description: 'Create/Browse test case for selected method'
		action: [:requestor | requestor getBrowser createTestCase]
		condition: [:r | true]! !

!TestCaseCreatorServiceProvider methodsFor: 'services' stamp: 'minami 3/17/2007 01:01'!
createTestCaseClass
	^ ServiceAction
		text: 'Create/Browse test case class'
		button: 'create/browse test case class'
		description: 'Create/Browse test case class for selected class'
		action: [:requestor | requestor getBrowser createTestCaseClass]
		condition: [:r | true]! !
TestCaseCreatorServiceProvider initialize!
